# Generated by YCM Generator at 2021-05-01 10:00:16.561585

# This file is NOT licensed under the GPLv3, which is the license for the rest
# of YouCompleteMe.
#
# Here's the license text for this file:
#
# This is free and unencumbered software released into the public domain.
#
# Anyone is free to copy, modify, publish, use, compile, sell, or
# distribute this software, either in source code form or as a compiled
# binary, for any purpose, commercial or non-commercial, and by any
# means.
#
# In jurisdictions that recognize copyright laws, the author or authors
# of this software dedicate any and all copyright interest in the
# software to the public domain. We make this dedication for the benefit
# of the public at large and to the detriment of our heirs and
# successors. We intend this dedication to be an overt act of
# relinquishment in perpetuity of all present and future rights to this
# software under copyright law.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# For more information, please refer to <http://unlicense.org/>

import os
import ycm_core

flags = [
    '-x',
    'c++',
    '-DNDEBUG',
    '-DOF_USING_GTK',
    '-DOF_USING_MPG123',
    '-D_REENTRANT',
    '-I/home/pointer/openFrameworks_master/addons/ofxRakau/emptyExample/src',
    '-I/home/pointer/openFrameworks_master/addons/ofxRakau/libs',
    '-I/home/pointer/openFrameworks_master/addons/ofxRakau/src',
    '-I/home/pointer/openFrameworks_master/libs/fmod/include',
    '-I/home/pointer/openFrameworks_master/libs/glm/include',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm/detail',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm/ext',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm/gtc',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm/gtx',
    '-I/home/pointer/openFrameworks_master/libs/glm/include/glm/simd',
    '-I/home/pointer/openFrameworks_master/libs/json/include',
    '-I/home/pointer/openFrameworks_master/libs/kiss/include',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/3d',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/app',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/communication',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/events',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/gl',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/graphics',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/math',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/sound',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/types',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/utils',
    '-I/home/pointer/openFrameworks_master/libs/openFrameworks/video',
    '-I/home/pointer/openFrameworks_master/libs/tess2/include',
    '-I/home/pointer/openFrameworks_master/libs/utf8/include',
    '-I/home/pointer/openFrameworks_master/libs/utf8/include/utf8',
    '-I/usr/include/AL',
    '-I/usr/include/at-spi-2.0',
    '-I/usr/include/at-spi2-atk/2.0',
    '-I/usr/include/atk-1.0',
    '-I/usr/include/blkid',
    '-I/usr/include/cairo',
    '-I/usr/include/dbus-1.0',
    '-I/usr/include/freetype2',
    '-I/usr/include/fribidi',
    '-I/usr/include/gdk-pixbuf-2.0',
    '-I/usr/include/gio-unix-2.0',
    '-I/usr/include/glib-2.0',
    '-I/usr/include/gstreamer-1.0',
    '-I/usr/include/gtk-3.0',
    '-I/usr/include/harfbuzz',
    '-I/usr/include/libmount',
    '-I/usr/include/libpng16',
    '-I/usr/include/orc-0.4',
    '-I/usr/include/pango-1.0',
    '-I/usr/include/pixman-1',
    '-I/usr/include/rtaudio',
    '-I/usr/include/uuid',
    '-I/usr/include/x86_64-linux-gnu',
    '-I/usr/lib/x86_64-linux-gnu/dbus-1.0/include',
    '-I/usr/lib/x86_64-linux-gnu/glib-2.0/include',
    '-Wall',
    '-Werror=return-type',
    '-std=c++11',
]


# Set this to the absolute path to the folder (NOT the file!) containing the
# compile_commands.json file to use that instead of 'flags'. See here for
# more details: http://clang.llvm.org/docs/JSONCompilationDatabase.html
#
# You can get CMake to generate this file for you by adding:
#   set( CMAKE_EXPORT_COMPILE_COMMANDS 1 )
# to your CMakeLists.txt file.
#
# Most projects will NOT need to set this to anything; you can just change the
# 'flags' list of compilation flags. Notice that YCM itself uses that approach.
compilation_database_folder = ''

if os.path.exists( compilation_database_folder ):
  database = ycm_core.CompilationDatabase( compilation_database_folder )
else:
  database = None

SOURCE_EXTENSIONS = [ '.C', '.cpp', '.cxx', '.cc', '.c', '.m', '.mm' ]

def DirectoryOfThisScript():
  return os.path.dirname( os.path.abspath( __file__ ) )


def MakeRelativePathsInFlagsAbsolute( flags, working_directory ):
  if not working_directory:
    return list( flags )
  new_flags = []
  make_next_absolute = False
  path_flags = [ '-isystem', '-I', '-iquote', '--sysroot=' ]
  for flag in flags:
    new_flag = flag

    if make_next_absolute:
      make_next_absolute = False
      if not flag.startswith( '/' ):
        new_flag = os.path.join( working_directory, flag )

    for path_flag in path_flags:
      if flag == path_flag:
        make_next_absolute = True
        break

      if flag.startswith( path_flag ):
        path = flag[ len( path_flag ): ]
        new_flag = path_flag + os.path.join( working_directory, path )
        break

    if new_flag:
      new_flags.append( new_flag )
  return new_flags


def IsHeaderFile( filename ):
  extension = os.path.splitext( filename )[ 1 ]
  return extension in [ '.H', '.h', '.hxx', '.hpp', '.hh' ]


def GetCompilationInfoForFile( filename ):
  # The compilation_commands.json file generated by CMake does not have entries
  # for header files. So we do our best by asking the db for flags for a
  # corresponding source file, if any. If one exists, the flags for that file
  # should be good enough.
  if IsHeaderFile( filename ):
    basename = os.path.splitext( filename )[ 0 ]
    for extension in SOURCE_EXTENSIONS:
      replacement_file = basename + extension
      if os.path.exists( replacement_file ):
        compilation_info = database.GetCompilationInfoForFile(
          replacement_file )
        if compilation_info.compiler_flags_:
          return compilation_info
    return None
  return database.GetCompilationInfoForFile( filename )


def FlagsForFile( filename, **kwargs ):
  if database:
    # Bear in mind that compilation_info.compiler_flags_ does NOT return a
    # python list, but a "list-like" StringVec object
    compilation_info = GetCompilationInfoForFile( filename )
    if not compilation_info:
      return None

    final_flags = MakeRelativePathsInFlagsAbsolute(
      compilation_info.compiler_flags_,
      compilation_info.compiler_working_dir_ )

  else:
    relative_to = DirectoryOfThisScript()
    final_flags = MakeRelativePathsInFlagsAbsolute( flags, relative_to )

  return {
    'flags': final_flags,
    'do_cache': True
  }

def Settings( **kwargs ):
    language = kwargs[ 'language' ]
    if language == 'cfamily':
        return {
            'flags': flags
        }

    return {}
